"""
List BodoSQL functions that have fixed args and variadic args
for use in distibuted_analysis.py.
"""

broadcasted_fixed_arg_functions = {
    "abs",
    "abs_decimal",
    "acos",
    "acosh",
    "add_date_interval_to_date",
    "add_interval",
    "add_interval_days",
    "add_interval_hours",
    "add_interval_microseconds",
    "add_interval_milliseconds",
    "add_interval_minutes",
    "add_interval_months",
    "add_interval_nanoseconds",
    "add_interval_quarters",
    "add_interval_seconds",
    "add_interval_weeks",
    "add_interval_years",
    "add_months",
    "add_numeric",
    "arr_get",
    "array_cat",
    "array_compact",
    "array_contains",
    "array_except",
    "array_intersection",
    "array_position",
    "array_remove",
    "array_remove_at",
    "array_size",
    "array_slice",
    "array_to_string",
    "arrays_overlap",
    "asin",
    "asinh",
    "atan",
    "atan2",
    "atanh",
    "base64_decode_binary",
    "base64_decode_string",
    "base64_encode",
    "bitand",
    "bitnot",
    "bitor",
    "bitshiftleft",
    "bitshiftright",
    "bitxor",
    "booland",
    "boolnot",
    "boolor",
    "boolxor",
    "cast_boolean",
    "cast_char",
    "cast_date",
    "cast_date_to_tz_aware",
    "cast_float32",
    "cast_float64",
    "cast_int16",
    "cast_int32",
    "cast_int64",
    "cast_int8",
    "cast_interval",
    "cast_str_to_tz_aware",
    "cast_timestamp",
    "cast_tz_aware_to_tz_naive",
    "cast_tz_naive_to_tz_aware",
    "cbrt",
    "ceil",
    "change_event",
    "char",
    "cond",
    "construct_timestamp",
    "contains",
    "conv",
    "convert_timezone_ntz",
    "convert_timezone_tz",
    "cos",
    "cosh",
    "cot",
    "create_timestamp",
    "date_format",
    "date_from_parts",
    "date_trunc",
    "dayname",
    "dayofmonth",
    "dayofweek",
    "dayofweekiso",
    "dayofyear",
    "degrees",
    "diff_day",
    "diff_hour",
    "diff_microsecond",
    "diff_millisecond",
    "diff_minute",
    "diff_month",
    "diff_nanosecond",
    "diff_quarter",
    "diff_second",
    "diff_week",
    "diff_year",
    "div0",
    "divide_numeric",
    "editdistance_no_max",
    "editdistance_with_max",
    "endswith",
    "equal",
    "equal_null",
    "exp",
    "factorial",
    "factorial_decimal",
    "floor",
    "format",
    "from_days",
    "get_epoch",
    "get_hour",
    "get_microsecond",
    "get_millisecond",
    "get_minute",
    "get_month",
    "get_nanosecond",
    "get_path",
    "get_quarter",
    "get_second",
    "get_timezone_offset",
    "get_weekofyear",
    "get_year",
    "get_ignore_case",
    "getbit",
    "greater_than",
    "greater_than_or_equal",
    "haversine",
    "hex_decode_binary",
    "hex_decode_string",
    "hex_encode",
    "initcap",
    "insert",
    "instr",
    "int_to_days",
    "interval_add_interval",
    "interval_multiply",
    "is_array",
    "is_false",
    "is_not_false",
    "is_not_true",
    "is_true",
    "is_object",
    "jarowinkler_similarity",
    "json_extract_path_text",
    "last_day_month",
    "last_day_quarter",
    "last_day_week",
    "last_day_year",
    "left",
    "length",
    "less_than",
    "less_than_or_equal",
    "like_kernel",
    "ln",
    "log",
    "log10",
    "log2",
    "lower",
    "lpad",
    "ltrim",
    "makedate",
    "md5",
    "modulo_numeric",
    "monthname",
    "months_between",
    "multiply_decimals",
    "divide_decimals",
    "multiply_numeric",
    "negate",
    "negate_interval",
    "next_day",
    "not_equal",
    "not_equal_null",
    "nullif",
    "numeric_to_decimal",
    "nvl2",
    "object_insert",
    "object_keys",
    "ord_ascii",
    "parse_json",
    "position",
    "power",
    "previous_day",
    "radians",
    "regexp_count",
    "regexp_instr",
    "regexp_like",
    "regexp_replace",
    "regexp_substr",
    "regr_valx",
    "regr_valy",
    "repeat",
    "replace",
    "reverse",
    "right",
    "round_decimal",
    "round",
    "rpad",
    "rtrim",
    "rtrimmed_length",
    "second_timestamp",
    "sha2",
    "sign",
    "sign_decimal",
    "sin",
    "sinh",
    "space",
    "split",
    "split_part",
    "sqrt",
    "square",
    "startswith",
    "strcmp",
    "string_to_decimal",
    "strtok",
    "strtok_to_array",
    "substring",
    "substring_index",
    "substring_suffix",
    "subtract_numeric",
    "tan",
    "tanh",
    "time_from_parts",
    "time_slice",
    "timestamp_from_date_and_time",
    "timestamp_tz_from_parts",
    "to_array",
    "to_binary",
    "to_boolean",
    "to_char",
    "to_date",
    "to_days",
    "to_decimal",
    "to_double",
    "to_number",
    "to_numeric",
    "to_seconds",
    "to_time",
    "to_timestamp",
    "to_timestamptz",
    "to_varchar",
    "translate",
    "trim",
    "trunc",
    "trunc_decimal",
    "try_to_binary",
    "try_to_boolean",
    "try_to_date",
    "try_to_decimal",
    "try_to_double",
    "try_to_number",
    "try_to_numeric",
    "try_to_timestamp",
    "tz_aware_interval_add",
    "uniform",
    "uuid4",
    "uuid5",
    "upper",
    "week",
    "weekday",
    "weekofyear",
    "width_bucket",
    "year_timestamp",
    "yearofweek",
    "yearofweekiso",
    "parse_url",
}

broadcasted_variadic_functions = {
    "array_construct",
    "coalesce",
    "decode",
    "greatest",
    "least",
    "object_construct",
    "object_construct_keep_null",
    "object_filter_keys",
    "sql_hash",
}
